Panda3D

Public Member Functions | List of all members
LightReMutexDirect Class Reference

This class implements a standard lightReMutex by making direct calls to the underlying implementation layer. More...

`#include "lightReMutexDirect.h"`

Inheritance diagram for LightReMutexDirect:

## Public Member Functions
void | acquire () const
| Grabs the lightReMutex if it is available. More...
void | acquire (Thread *current_thread) const
| This variant on acquire() accepts the current thread as a parameter, if it is already known, as an optimization. More...
void | clear_name ()
| The mutex name is only defined when compiling in DEBUG_THREADS mode. More...
bool | debug_is_locked () const
| Returns true if the current thread has locked the LightReMutex, false otherwise. More...
void | elevate_lock () const
| This method increments the lock count, assuming the calling thread already holds the lock. More...
std::string | get_name () const
| The mutex name is only defined when compiling in DEBUG_THREADS mode. More...
bool | has_name () const
| The mutex name is only defined when compiling in DEBUG_THREADS mode. More...
void | lock ()
| Alias for acquire() to match C++11 semantics. More...
void | output (std::ostream &out) const
| This method is declared virtual in MutexDebug, but non-virtual in LightReMutexDirect. More...
void | release () const
| Releases the lightReMutex. More...
void | set_name (const std::string &name)
| The mutex name is only defined when compiling in DEBUG_THREADS mode. More...
bool | try_lock ()
| Alias for try_acquire() to match C++11 semantics. More...
void | unlock ()
| Alias for release() to match C++11 semantics. More...

## Detailed Description

This class implements a standard lightReMutex by making direct calls to the underlying implementation layer.

It doesn't perform any debugging operations.

Definition at line 29 of file lightReMutexDirect.h.

## Member Function Documentation

## ◆ acquire() [1/2]

void LightReMutexDirect::acquire | ( |  | ) | const
| inline

Grabs the lightReMutex if it is available.

If it is not available, blocks until it becomes available, then grabs it. In either case, the function does not return until the lightReMutex is held; you should then call unlock().

This method is considered const so that you can lock and unlock const lightReMutexes, mainly to allow thread-safe access to otherwise const data.

Also see LightReMutexHolder.

Definition at line 55 of file lightReMutexDirect.I.

## ◆ acquire() [2/2]

void LightReMutexDirect::acquire | ( | Thread * | current_thread | ) | const
| inline

This variant on acquire() accepts the current thread as a parameter, if it is already known, as an optimization.

Definition at line 69 of file lightReMutexDirect.I.

## ◆ clear_name()

void LightReMutexDirect::clear_name | ( |  | ) |
| inline

The mutex name is only defined when compiling in DEBUG_THREADS mode.

Definition at line 137 of file lightReMutexDirect.I.

## ◆ debug_is_locked()

bool LightReMutexDirect::debug_is_locked | ( |  | ) | const
| inline

Returns true if the current thread has locked the LightReMutex, false otherwise.

This method is only intended for use in debugging, hence the method name; in the LightReMutexDirect case, it always returns true, since there's not a reliable way to determine this otherwise.

Definition at line 122 of file lightReMutexDirect.I.

## ◆ elevate_lock()

void LightReMutexDirect::elevate_lock | ( |  | ) | const
| inline

This method increments the lock count, assuming the calling thread already holds the lock.

After this call, release() will need to be called one additional time to release the lock.

This method really performs the same function as acquire(), but it offers a potential (slight) performance benefit when the calling thread knows that it already holds the lock. It is an error to call this when the calling thread does not hold the lock.

Definition at line 89 of file lightReMutexDirect.I.

## ◆ get_name()

std::string LightReMutexDirect::get_name | ( |  | ) | const
| inline

The mutex name is only defined when compiling in DEBUG_THREADS mode.

Definition at line 152 of file lightReMutexDirect.I.

## ◆ has_name()

bool LightReMutexDirect::has_name | ( |  | ) | const
| inline

The mutex name is only defined when compiling in DEBUG_THREADS mode.

Definition at line 144 of file lightReMutexDirect.I.

## ◆ lock()

void LightReMutexDirect::lock | ( |  | ) |
| inline

Alias for acquire() to match C++11 semantics.

See also
  acquire()

Definition at line 18 of file lightReMutexDirect.I.

## ◆ output()

void LightReMutexDirect::output | ( | std::ostream & | out | ) | const

This method is declared virtual in MutexDebug, but non-virtual in LightReMutexDirect.

Definition at line 23 of file lightReMutexDirect.cxx.

## ◆ release()

void LightReMutexDirect::release | ( |  | ) | const
| inline

Releases the lightReMutex.

It is an error to call this if the lightReMutex was not already locked.

This method is considered const so that you can lock and unlock const lightReMutexes, mainly to allow thread-safe access to otherwise const data.

Definition at line 106 of file lightReMutexDirect.I.

## ◆ set_name()

void LightReMutexDirect::set_name | ( | const std::string & | name | ) |
| inline

The mutex name is only defined when compiling in DEBUG_THREADS mode.

Definition at line 130 of file lightReMutexDirect.I.

## ◆ try_lock()

bool LightReMutexDirect::try_lock | ( |  | ) |
| inline

Alias for try_acquire() to match C++11 semantics.

See also
  try_acquire()

Definition at line 28 of file lightReMutexDirect.I.

## ◆ unlock()

void LightReMutexDirect::unlock | ( |  | ) |
| inline

Alias for release() to match C++11 semantics.

See also
  release()

Definition at line 38 of file lightReMutexDirect.I.

The documentation for this class was generated from the following files:

- panda/src/pipeline/lightReMutexDirect.h
- panda/src/pipeline/lightReMutexDirect.cxx
- panda/src/pipeline/lightReMutexDirect.I